// this is my drawing box crap

#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"

Class xbpDrawStatic From DC_XbpStatic
  Exported:
    // Default overloaded parameters
    Method Init
    Method Create
    Method Destroy
    Method lbDown
    Method lbUp
    Method Motion

    // Custom Methods
    Method SetTool
    Method SetPenSize
    Method SetBGC
    Method SetFGC
    Method SetUndoSize
    Method UndoLast
    Method CanUndo
    Method RePaint
    Method HandleEvent
    Method SaveFile
    Method LoadFile
    METHOD Reset

  Protected:
    Var oPS
    Var oDlg
    Var MouseDown
    Var aOldPos
    Var ToolNum
    Var nPenSize
    Var FGColor
    Var BGColor
    Var aUndoBuffer
    Var oSaveScreen
    VAR oEmptyScreen
    Var aScreenSize

EndClass

// init procedure for class
Method xbpDrawStatic:Init(oParent,oOwner,aPos,aSize,aAttr,lVisable,x,y,z)

  // tell it we will be drawing a static on the form and set it up
  ::oDlg := ::DC_XbpStatic:init(oParent,oOwner,aPos,aSize,aAttr,lVisable,x,y,z)

  // set up some defaults
  ::ToolNum  := 1
  ::nPenSize := 4

  ::FGColor  := xRGB({0,0,0})
  ::BGColor  := xRGB({255,255,255})

  ::aUndoBuffer := Array(10)
  ::aScreenSize := aSize

Return Self

Method xbpDrawStatic:UndoLast()

  Local vItem := aPop(::aUndoBuffer)
  GraRestScreen(::oPS,{0,0},vItem)

Return If(Empty(::aUndoBuffer[1]),.F.,.T.)

Method xbpDrawStatic:SetUndoSize(nSize)
  Local nOld := Len(::aUndoBuffer)

  If ! Empty(nSize)
    ::aUndoBuffer := Array(nSize)
  EndIf

Return nOld

Method xbpDrawStatic:HandleEvent(nEvent,mp1,mp2)
::DC_XbpStatic:HandleEvent(nEvent,@mp1,@mp2)
if nEvent == xbeP_Paint
   if ValType(::oEmptyScreen) <> "O"
      ::oEmptyScreen := GraSaveScreen(::oPS,{0,0},::aScreenSize)
      ::oSaveScreen  := GraSaveScreen(::oPS,{0,0},::aScreenSize)
   endif
   ::Repaint()
endif
Return SELF

Method xbpDrawStatic:Repaint()
if Valtype(::oSaveScreen) = "O"
  GraRestScreen(::oPS,{0,0},::oSaveScreen)
endif
return SELF


// the actual creation of the class will be handled here
Method xbpDrawStatic:Create(oParent,oOwner,aPos,aSize,aAttr,lVisable)

  // this is going to be a static colored in the background color
  // which is passed as aPresParams

  // call create on the static we have created in init using same params
  ::oDlg := ::DC_XbpStatic:Create(oParent,oOwner,aPos,aSize,aAttr,lVisable)

  // make and save the presentation space
  ::oPS := XBpPresSpace():New()
  ::oPS:Create(::oDlg:WinDevice())

//  ::oSaveScreen := GraSaveScreen(::oPS,{0,0},::aScreenSize)

  ::MouseDown:= .F.

  If Empty(::aScreenSize)
    ::aScreenSize := aSize
  EndIf
Return self

// this will handle what all we need to get rid of when we destroy
// an object of this class
Method xbpDrawStatic:Destroy()
  // destory the presentation space we made
  ::oPS:Destroy()

  // destroy the static we have made
  ::oDlg:Destroy()
Return Self

Method xbpDrawStatic:lbDown(aPos)
  ::oSaveScreen := GraSaveScreen(::oPS,{0,0},::aScreenSize)
  ::MouseDown := .T.

  If ::ToolNum <> 1
    ::aOldPos := aPos
  EndIf

Return Self

Method xbpDrawStatic:lbUp(aPos)

  aPush(::aUndoBuffer,::oSaveScreen)
  ::oSaveScreen := GraSaveScreen(::oPS,{0,0},::aScreenSize)

  ::MouseDown := .F.
  ::aOldPos   := {}
Return Self


// this is going to handle all of the mouse drawing functions
Method xbpDrawStatic:Motion( aPos )
  Local nX1, nY1, nX2, nY2, nDistance, nX, nXCalc, nYCalc

  // if the mouse has registered as being in the down state
  If ::MouseDown

    // this will set the color of the tool we will be using
    GraSetColor(::oPS,::FGColor,::BGColor)

    If ::ToolNum == 1                                /****  Marker Tool ****/

      // draw a line from the last pos to this pos
      ::aOldPos := IIF(Empty(::aOldPos),aPos,::aOldPos)

      nX1 := ::aOldPos[1]
      nY1 := (::aOldPos[2])
      nX2 := aPos[1]
      nY2 := (aPos[2])

      // since there is no line width attribute, we will need to
      // go complete redneck and manually draw in the lin using the
      // marker tool settings.  To get all the points on a line we
      // will need to get the length of the line then find each point
      // along that line.  To Do this we will use the distance formula
      // and the equation of a line formula.
      //
      //    The Distance Between Two Points
      //    Sqrt( (nX2-nX1)^2 + (nY2-nY1)^2)
      //
      //    The Equation of A Line Formula
      //                   (x2-x1)d                        (y2-y1)d
      //    (x1 + -------------------------, y1 + -------------------------)
      //          sqrt((x2-x1)^2+(y2-y1)^2)       sqrt((x2-x1)^2+(y2-y1)^2)
      nDistance := Sqrt((nX2-nX1)**2 + (nY2-nY1)**2)

      For nX := 1 To nDistance Step (::nPenSize/2)

        nXCalc := nX1 + ( ((nX2-nX1)*nX)/Sqrt( (nX2-nX1)**2 + (nY2-nY1)**2 ) )
        nYCalc := nY1 + ( ((nY2-nY1)*nX)/Sqrt( (nX2-nX1)**2 + (nY2-nY1)**2 ) )

        GraArc(::oPS,{nXCalc,nYCalc},::nPenSize,,,,GRA_FILL)

      Next nX

      // put the current pos as the old pos for the next one
      ::aOldPos := aPos

      // draw the dot where we are at
      GraArc(::oPS,aPos,::nPenSize,,,,GRA_FILL)

    ElseIf ::ToolNum == 2                          /****   Line Tool  ****/


      GraRestScreen(::oPS,{0,0},::oSaveScreen)

      nX1 := ::aOldPos[1]
      nY1 := (::aOldPos[2])
      nX2 := aPos[1]
      nY2 := (aPos[2])

      // since there is no line width attribute, we will need to
      // go complete redneck and manually draw in the lin using the
      // marker tool settings.  To get all the points on a line we
      // will need to get the length of the line then find each point
      // along that line.  To Do this we will use the distance formula
      // and the equation of a line formula.
      //
      //    The Distance Between Two Points
      //    Sqrt( (nX2-nX1)^2 + (nY2-nY1)^2)
      //
      //    The Equation of A Line Formula
      //                   (x2-x1)d                        (y2-y1)d
      //    (x1 + -------------------------, y1 + -------------------------)
      //          sqrt((x2-x1)^2+(y2-y1)^2)       sqrt((x2-x1)^2+(y2-y1)^2)
      nDistance := Sqrt((nX2-nX1)**2 + (nY2-nY1)**2)

      For nX := 1 To nDistance Step 4

        nXCalc := nX1 + ( ((nX2-nX1)*nX)/Sqrt( (nX2-nX1)**2 + (nY2-nY1)**2 ) )
        nYCalc := nY1 + ( ((nY2-nY1)*nX)/Sqrt( (nX2-nX1)**2 + (nY2-nY1)**2 ) )

        GraArc(::oPS,{nXCalc,nYCalc},::nPenSize,,,,GRA_FILL)

      Next nX
    ElseIf ::ToolNum == 3  // Circle Tool

      GraRestScreen(::oPS,{0,0},::oSaveScreen)

      nX1 := ::aOldPos[1]
      nY1 := (::aOldPos[2])
      nX2 := aPos[1]
      nY2 := (aPos[2])

      //    The Distance Between Two Points
      //    Sqrt( (nX2-nX1)^2 + (nY2-nY1)^2)
      nDistance := Sqrt((nX2-nX1)**2 + (nY2-nY1)**2)

      // get the center point of the line
      nXCalc := nX1 + ( ((nX2-nX1)*(nDistance/2))/Sqrt( (nX2-nX1)**2 + (nY2-nY1)**2 ) )
      nYCalc := nY1 + ( ((nY2-nY1)*(nDistance/2))/Sqrt( (nX2-nX1)**2 + (nY2-nY1)**2 ) )

      // draw the outer ring
      For nX := 1 To ::nPenSize*2
        GraArc(::oPS,{nXCalc,nYCalc},(nDistance/2)-nX,,,,)
      Next nX

    ElseIf ::ToolNum == 4  // rectangle tool
      GraRestScreen(::oPS,{0,0},::oSaveScreen)

      nX1 := ::aOldPos[1]
      nY1 := (::aOldPos[2])
      nX2 := aPos[1]
      nY2 := (aPos[2])

      For nX := 1 To ::nPenSize
        GraBox(::oPS,{nX2-nX,nY2+nX},{nX1+nX,nY1-nX})
      Next nX

    EndIf

  EndIf

Return Self

Method xbpDrawStatic:SetTool(nTool)
  // save the old tool so that we can return it
  Local nOldTool := ::ToolNum

  // if we did not specify a tool, we will not change
  // the tool number
  If !Empty(nTool)
    ::ToolNum := nTool
  EndIf

Return nOldTool

Method xbpDrawStatic:SetPenSize(nSize)
  // save the old pen size so we can return it
  Local nOldPen := ::nPenSize

  If !Empty(nSize)
    ::nPenSize := nSize
  EndIf

Return nOldPen

Method xbpDrawStatic:CanUndo()
Return If(Empty(::aUndoBuffer[1]),.F.,.T.)

Method xbpDrawStatic:SetBGC(nColor)
  Local nOldColor := ::BGColor

  If !Empty(nColor)
    ::BGColor := nColor
    ::SetColorBG(nColor)
  EndIf

Return nOldColor

Method xbpDrawStatic:SetFGC(nColor)
  Local nOldColor := ::FGColor

  If !Empty(nColor)
    ::FGColor := nColor
  EndIf

Return nOldColor

Method xbpDrawStatic:Reset()
::oSaveScreen:SetBuffer(::oEmptyScreen:SetBuffer())
::Repaint()
Return


Method xbpDrawStatic:SaveFile()
MemoWrit("MyImage.dat",::oSaveScreen:SetBuffer(,XBPBMP_FORMAT_PNG))
Return

Method xbpDrawStatic:LoadFile()
if File("MyImage.dat")
   ::oSaveScreen:SetBuffer(MemoRead("MyImage.dat"),XBPBMP_FORMAT_PNG)
   ::Repaint()
endif
Return


Function xRGB(cColor)
Return GraMakeRGBColor(cColor)

Function GraSaveScreen( oSourcePS, aPos, aSize)
  Local oBitmap   := xbpBitmap():New():Create(oSourcePS)
  Local oTargetPS := xbpPresSpace():New():Create()
  Local aSourceRect[4], aTargetRect

  aSourceRect[1] := aSourceRect[3] := aPos[1]
  aSourceRect[2] := aSourceRect[4] := aPos[2]
  aSourceRect[3] += aSize[1]
  aSourceRect[4] += aSize[2]

  aTargetRect    := {0,0,aSize[1],aSize[2]}

  oBitmap:PresSpace(oTargetPS)
  oBitmap:Make(aSize[1],aSize[2])

  GraBitBlt(oTargetPS, oSourcePS, aTargetRect,aSourceRect)
Return oBitmap

Procedure GraRestScreen(oTargetPS,aPos,oBitmap)
  oBitmap:Draw(oTargetPS,aPos)
Return

Procedure aPush(aArray,vItem)
  aIns(aArray,1,vItem)
Return

Function aPop(aArray)
  Local vItem := aArray[1]
  aDel(aArray,1)
Return vItem
